package cs131w.assembly;


public interface Asmbl {

	//statics
	public static final String NULL = "0";
	
	//register defs
	public static final String FP 	= "%fp";
	public static final String SP 	= "%sp";
	
	//global
	public static final String G0 	= "%g0";
	public static final String G1 	= "%g1";
	public static final String G2 	= "%g2";
	public static final String G3 	= "%g3";
	public static final String G4 	= "%g4";
	public static final String G5 	= "%g5";
	public static final String G6 	= "%g6";
	public static final String G7 	= "%g7";
	
	//local
	public static final String L0 	= "%l0";		//always result of some op
	public static final String L1 	= "%l1";		//use for whatever
	public static final String L2 	= "%l2";		//use for whatever
	public static final String L3 	= "%l3";		//..
	public static final String L4 	= "%l4";
	public static final String L5 	= "%l5";
	public static final String L6 	= "%l6";		//use for immediates, ie. const values
	public static final String L7 	= "%l7";		//always dest for set instr.
	
	//in
	public static final String I0 	= "%i0";
	public static final String I1 	= "%i1";
	public static final String I2 	= "%i2";
	public static final String I3 	= "%i3";
	public static final String I4 	= "%i4";
	public static final String I5 	= "%i5";

	//out
	public static final String O0 	= "%o0";
	public static final String O1 	= "%o1";
	public static final String O2 	= "%o2";
	public static final String O3 	= "%o3";
	public static final String O4 	= "%o4";
	public static final String O5 	= "%o5";


	//floating point regs
	public static final String F0 	= "%f0";	
	public static final String F1 	= "%f1";	
	public static final String F2 	= "%f2";	
	public static final String F3 	= "%f3";		//..
	public static final String F4 	= "%f4";
	public static final String F5 	= "%f5";
	public static final String F6 	= "%f6";
	public static final String F7 	= "%f7";	
	public static final String F8 	= "%f8";	
	public static final String F9 	= "%f9";	
	public static final String F10 	= "%f10";	
	public static final String F11 	= "%f11";		//..
	public static final String F12 	= "%f12";
	public static final String F13 	= "%f13";
	public static final String F14 	= "%f14";
	public static final String F15 	= "%f15";	

	// .....
	
	public static final String F31 	= "%f31";	
	
	
	//section definitions
	public static final int TEXT 	= 0;
	public static final int DATA 	= 1;
	public static final int RODATA 	= 2;
	public static final int BSS 	= 3;


	public static final String SEPARATOR 	= "\t\t";
	public static final String IND	 		= "\t\t\t";

	public static final String ERROR 		= "! ============ Error occured: %s ============ !";
	public static final String COMMENT 		= "! %s";
	public static final String COMM 		= "\t\t";
	public static final String COMM0 		= COMM + " ";
	public static final String COMM1 		= "";	// "\t" + COMM0;
	public static final String COMM2 		= "";	//"\t" + COMM1;
	public static final String COMM3 		= "";	//"\t" + COMM2;
	public static final String COMM4 		= "";	//"\t" + COMM3;
	public static final String COMM5 		= "";	//"\t" + COMM4;
	public static final String COMM6 		= "";	//"\t" + COMM5;
	public static final String COMM7 		= "";	//"\t" + COMM6;
	public static final String COMM8 		= "";	//"\t" + COMM7;
	public static final String COMM9 		= "";	//"\t" + COMM8;
	
	public static final String LABEL 		= "%s:\t\t\t\t\t\t" + COMM8;
	public static final String VAR 			= "%s = %s" + "\t\t\t";

	public static final String GLOBAL 		= IND + ".global" + SEPARATOR + "%s" + COMM3;
	public static final String ALIGN_S 		= IND + ".align" + SEPARATOR + "%s" + COMM4;
	public static final String SKIP 		= IND + ".skip" + SEPARATOR + "%s" + COMM4;

    public static final String SECT_SEP 	= "! ---------------------------------- \n";
    public static final String SECTION_S 	= SECT_SEP + IND + ".section\t";
	public static final String TEXT_S 		= SECTION_S  +"\".text\"" + COMM3;
	public static final String DATA_S 		= SECTION_S  +"\".data\"" + COMM3;
	public static final String RODATA_S 	= SECTION_S  +"\".rodata\"" + COMM2;
	public static final String BSS_S 		= SECTION_S  +"\".bss\"" + COMM3;
	

	public static final String WORD_VAR_INIT 	= "%s:\n" + IND + ".word"	+ SEPARATOR + "%s"  + COMM3;
	public static final String FLOAT_VAR_INIT 	= "%s:\n" + IND + ".single"	+ SEPARATOR + "0r%s" + COMM3;
	public static final String STRING_VAR_INIT 	= "%s:\n" + IND + ".asciz"	+ SEPARATOR + "\"%s\"" + COMM3;
	
	public static final String ZERO_PARAM 	= IND + "%s";
	public static final String ONE_PARAM 	= IND + "%s" + SEPARATOR + "%s";
	public static final String TWO_PARAM 	= IND + "%s" + SEPARATOR + "%s, %s";
	public static final String THREE_PARAM 	= IND + "%s" + SEPARATOR + "%s, %s, &s";

    
	//0 args
    public static final String NOP 			= IND + "nop" + "\t\t\t";
	public static final String RET 			= IND + "ret" + "\t\t\t";
	public static final String RESTORE 		= IND + "restore" + "\t\t";

	//1 arg
	public static final String CALL 		= IND + "call" + SEPARATOR + "%s" + COMM3;
	public static final String JUMP 		= IND + "jmp\t" + SEPARATOR + "%s" + COMM2;
	public static final String INC 			= IND + "inc\t" + SEPARATOR + "%s" + COMM2;
	public static final String DEC	 		= IND + "dec\t" + SEPARATOR + "%s" + COMM2;
	public static final String INCA 		= IND + "inc\t" + SEPARATOR + "%s, %s" + COMM2;
	public static final String DECA	 		= IND + "dec\t" + SEPARATOR + "%s, %s" + COMM2;

	//branches: bg, bge, bl, ble, be, bne, ba
	public static final String BG	 		= IND + "bg\t" + SEPARATOR + "%s" + COMM2;
	public static final String BGU	 		= IND + "bgu\t" + SEPARATOR + "%s" + COMM2;
	public static final String BGE 			= IND + "bge\t" + SEPARATOR + "%s" + COMM2;
	public static final String BL 			= IND + "bl\t" + SEPARATOR + "%s" + COMM2;
	public static final String BLU 			= IND + "blu\t" + SEPARATOR + "%s" + COMM2;
	public static final String BLE 			= IND + "ble" + SEPARATOR + "%s" + COMM2;
	public static final String BE 			= IND + "be\t" + SEPARATOR + "%s" + COMM2;
	public static final String BNE 			= IND + "bne\t" + SEPARATOR + "%s" + COMM2;
	public static final String BA 			= IND + "ba\t" + SEPARATOR + "%s" + COMM2;

	//branches: bg, bge, bl, ble, be, bne, ba
	public static final String FBG	 		= IND + "fbg\t" + SEPARATOR + "%s" + COMM2;
	public static final String FBGE 		= IND + "fbge" + SEPARATOR + "%s" + COMM2;
	public static final String FBL 			= IND + "fbl\t" + SEPARATOR + "%s" + COMM2;
	public static final String FBLE 		= IND + "fble" + SEPARATOR + "%s" + COMM2;
	public static final String FBE 			= IND + "fbe" + SEPARATOR + "%s" + COMM2;
	public static final String FBNE 		= IND + "fbne" + SEPARATOR + "%s" + COMM2;
	public static final String FBA 			= IND + "fba\t" + SEPARATOR + "%s" + COMM2;
	
	
	//2 args
	public static final String SET 			= IND + "set\t" + SEPARATOR + "%s, %s" + COMM2;
	public static final String LOAD 		= IND + "ld\t" + SEPARATOR + "[%s], %s" + COMM2;
	public static final String STORE 		= IND + "st\t" + SEPARATOR + "%s, [%s]" + COMM2;
	public static final String MOVE 		= IND + "mov\t" + SEPARATOR + "%s, %s" + COMM2;
	public static final String FMOVE 		= IND + "fmovs" + SEPARATOR + "%s, %s" + COMM2;
	public static final String CMP 			= IND + "cmp\t" + SEPARATOR + "%s, %s" + COMM2;
	public static final String FCMP 		= IND + "fcmps" + SEPARATOR + "%s, %s" + COMM2;
	public static final String FITOS		= IND + "fitos" + SEPARATOR + "%s, %s" + COMM2;
	public static final String FSTOI		= IND + "fstoi" + SEPARATOR + "%s, %s" + COMM2;
	
	//
	public static final String NEG	 		= IND + "neg\t" + SEPARATOR + "%s, %s" + COMM2; //1's complement
	public static final String NOT 			= IND + "not\t" + SEPARATOR + "%s, %s" + COMM2; //2's complement

	//3 args
    public static final String SAVE 		= IND + "save" + SEPARATOR + "%s, %s, %s" + COMM1;
	//arithmetic
	public static final String ADD 			= IND + "add\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String SUB 			= IND + "sub\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	//logical
	public static final String AND 			= IND + "and\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String OR 			= IND + "or\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String XOR 			= IND + "xor\t" + SEPARATOR + "%s, %s, %s" + COMM1;

	//float
	//arithmetic
	public static final String FADD 		= IND + "fadds" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String FSUB 		= IND + "fsubs" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String FMUL 		= IND + "fmuls" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String FDIV 		= IND + "fdivs" + SEPARATOR + "%s, %s, %s" + COMM1;
	
	public static final String FNEG			= IND + "fnegs" + SEPARATOR + "%s, %s" + COMM2; 
	
	//shifts
	public static final String SLL 			= IND + "sll\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String SLR 			= IND + "slr\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	public static final String SRA 			= IND + "sra\t" + SEPARATOR + "%s, %s, %s" + COMM1;
	

}