package cs131w.stmts;

import cs131w.assembly.Asmbl;
import cs131w.assembly.AssemblyWriter;
import cs131w.symtab.sto.STO;
import cs131w.parser.MyParser;

public class IfStmt extends Stmt {
	private static int IF_COUNTER = 0;
	private String ifLabel;
	private String elseLabel;
	private String endLabel;
	private STO sto;
	
	public IfStmt(STO sto){
		ifLabel = getNewIfLabel();
		elseLabel = getNewElseLabel();
		endLabel = getNewEndLabel();
		this.sto = sto;
	}
	
	public void printCmp(){
		//TODO sto.figureOut();
		sto.AsmblyLoad();
		AssemblyWriter.writeSmt(CMP, sto.getRegister(), G0);
		AssemblyWriter.writeSmt(BNE, ifLabel);
		AssemblyWriter.writeSmt(NOP);
		AssemblyWriter.writeSmt(BE, elseLabel);
		AssemblyWriter.writeSmt(NOP);
		sto.AsmblyClearReg();
	}
	
	public void printIf(){
		AssemblyWriter.switchSection(TEXT);
		AssemblyWriter.writeSmt(LABEL, ifLabel);
	}
	
	public void printElse(){
		AssemblyWriter.switchSection(TEXT);
		AssemblyWriter.writeSmt(BA, endLabel);
		AssemblyWriter.writeSmt(NOP);
		AssemblyWriter.writeSmt(LABEL, elseLabel);
	}
	
	public void printEnd(){
		AssemblyWriter.switchSection(TEXT);
		AssemblyWriter.writeSmt(LABEL, endLabel);
	}
	
	protected static String getNewIfLabel(){
		return "if_code_" + (++IF_COUNTER)  + "$L" + MyParser.GetLineNum();
	}
	
	protected static String getNewElseLabel(){
		return "else_code_" + IF_COUNTER  + "$L" + MyParser.GetLineNum();
	}
	
	protected static String getNewEndLabel(){
		return "if_end_" + IF_COUNTER  + "$L" + MyParser.GetLineNum();
	}
	
}
