package cs131w.stmts;

import cs131w.assembly.Asmbl;
import cs131w.assembly.AssemblyWriter;
import cs131w.symtab.sto.STO;
import cs131w.parser.MyParser;

public class WhileStmt extends Stmt {
	private static int WHILE_COUNTER = 0;
	private String topLabel;
	private String endLabel;
	private STO sto;
	
	public WhileStmt(){
		topLabel = getNewTopLabel();
		endLabel = getNewEndLabel();
		sto = null;
	}
	
	public WhileStmt(STO sto){
		this.sto = sto;
		topLabel = getNewTopLabel();
		endLabel = getNewEndLabel();
	}
	
	public void setSTO(STO sto){
		this.sto = sto;
	}
	
	public void printTop(){
		AssemblyWriter.switchSection(TEXT);
		AssemblyWriter.writeSmt(LABEL, topLabel);

	}
	public void printCmp(){
		//TODO sto.figureOut();
		if(sto == null) throw new RuntimeException("While statement not initialized w/ STO!");
		sto.AsmblyLoad();
		AssemblyWriter.switchSection(TEXT);
		AssemblyWriter.writeSmt(CMP, sto.getRegister(), G0);
		AssemblyWriter.writeSmt(BE, endLabel);
		AssemblyWriter.writeSmt(NOP);
		sto.AsmblyClearReg();
	}
	
	public void printEnd(){
		AssemblyWriter.switchSection(TEXT);
		AssemblyWriter.writeSmt(BA, topLabel);
		AssemblyWriter.writeSmt(NOP);
		AssemblyWriter.writeSmt(LABEL, endLabel );
	}
	
	protected static String getNewTopLabel(){
		return "while_top_" + (++WHILE_COUNTER) + "$L" + MyParser.GetLineNum();
	}
	
	protected static String getNewEndLabel(){
		return "while_end_" + WHILE_COUNTER + "$L" + MyParser.GetLineNum();
	}
	
	public String getTopLabel(){
		return topLabel;
	}
	public String getEndLabel(){
		return endLabel;
	}
}
