package cs131w.symtab.ops;

//---------------------------------------------------------------------
// equlity ops, = !=
//---------------------------------------------------------------------
import  cs131w.lexer.*;
import  cs131w.parser.*;
import cs131w.symtab.ops.binary.CastOp;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public abstract class BoolOp extends Operator{
	protected STO operand;
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	BoolOp ()
	{
		super("", null);
	}
	

	public 
	BoolOp (String strName, Token tok)
	{
		super(strName, tok);
	}

	//as a bool op this only applies to the NOT op
	public STO checkOperand(STO a) { 
		MyParser.debug(this + ": checking " + a);
		
		if ( !a.getType().isBool()){
			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1u_Expr, a.getType(), this, "bool")));
		} 	
		return a;
		
	}
	
	//this function needs to check both operands if they are equal or coercible and return appr type
	public STO checkOperands(STO a, STO b) { 
		
		if ( !a.getType().isBool()){
			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1w_Expr, a.getType(), this, "bool" )));
		}else if ( !b.getType().isBool()) { 
			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1w_Expr, b.getType(), this, "bool" )));		
		} 
		
		return a;
		
	}
	
	public STO operate(STO a, STO b){
		return (new ExprSTO("boolop", new BoolType()));
	}

	public STO operate(STO a){
		return (new ExprSTO("boolop", new BoolType()));
	}
	
	//this needs to be overwritten by each binary op
	//here we check what type of op we need to execute (write code for)
	public STO
	AsmblyDoOp(STO res, STO a, STO b){
		MyParser.asmblyWriteVarSmtComm(this + ": ", m_Template, a.getReg(), b.getReg(), L0);
		res.setReg(L0);
		return res;
	}


	public STO getOperand() {
		return operand;
	}
	
}