package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.*;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import cs131w.util.Utils;
import  cs131w.error.*;


public class AndOp extends BoolOp{
	String falseLabel;
	String endLabel;
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	AndOp ()
	{
		super("&&", new Token (sym.T_AND, "&&"));
		m_Template = AND;
		falseLabel = Utils.getSomeLabel("andop_false");
		endLabel = Utils.getSomeLabel("andop_end");
	}
	
	public STO operate(ConstSTO a, ConstSTO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
			
		STO res = new ConstSTO( a.getBoolValue() && b.getBoolValue() );
	
		res.setRVal();
		return res;
	}
	
	public STO operate(ConstSTO a){
		throw new RuntimeException();
	}
	
	public void shortCircuit(STO a){
		a.AsmblyLoad();
		MyParser.asmblyWriteVarSmtComm(this + ":", CMP, a.getReg(), "0");
		MyParser.asmblyWriteVarSmtComm(this + ":", BE, falseLabel);
		MyParser.asmblyWriteVarSmt(NOP);
		operand = a;
		a.AsmblyClearReg();
	}

	@Override
	public STO AsmblyDoOp(STO res, STO a, STO b) {
		res.setReg(L0);
		MyParser.asmblyWriteVarSmtComm(this + ": ", m_Template, a.getReg(), b.getReg(), L0);
		MyParser.asmblyWriteVarSmtComm(this + ":", BA, endLabel);
		MyParser.asmblyWriteVarSmt(NOP);
		MyParser.asmblyWriteVarSmt(LABEL, falseLabel);
		MyParser.asmblyWriteVarSmtComm("", SET, "0", L0);
		MyParser.asmblyWriteVarSmt(LABEL, endLabel);
		return res;
		
		
	}
	
	
	


}