package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// basic math ops, like +-*/
//---------------------------------------------------------------------
import  cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.ops.unary.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class ArrowOp extends BinaryOp{
	
	private Operator m_star;
	private Operator m_dot;

	private STO		 m_remStruct;
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	ArrowOp ()
	{
		super("->", new Token (sym.T_ARROW, "->"));
		m_star = new StarOp();
		m_dot = new DotOp();
		
	}
		
	//function that checks operand of this op
	public STO 
		checkOperands(STO a, STO b){

			MyParser.debug(this + ": checking " + a + ", with name: " + b);
			//this basically just needs to do a star and then a dot op in order
			
			STO sto = m_star.checkOperand(a);
			if (sto.isError()) {
				//need to pass up a different error Msg
				return new ErrorSTO (Formatter.toString(ErrorMsg.error15_ReceiverArrow, a.getType()));
			}
			
			sto = m_dot.checkOperands(m_star.operate(a), b);
			if (sto.isError()) {
				//just return that error
				return sto;
			}
			
			return a;
			
		}
	
	@Override
	public STO operate(STO a, STO b){
		//now we just need to run dot after star and return 
		MyParser.debug(this + ".operate: '" +a+ "', name= " + (b));
		
		m_remStruct = m_star.operate(a);
		
		return m_dot.operate(m_remStruct, b);
		
		//this needs to call both AsmblyOperate of star and dot itself
	}


	//------------------------------------------------------------------
	//this needs to be overwritten by each binary op
	//here we just do the neccasary code and labels for a comp
	public STO
	AsmblyDoOp(STO res, STO a, STO b){
		//this needs to call both AsmblyOperate of star and dot itself
	
		MyParser.debug(this + ".AsmblyDoOp: '" +a+ "', name='" + (b) + "', res='" + res + "', remStruct='" + m_remStruct +"'");
		
		STO sto;
		
		//now call star op AsmblyDoOp 
		sto = m_star.AsmblyDoOp(m_remStruct, a);
		
		//and the dot on returned value
		m_dot.AsmblyDoOp(res, sto, b);
		

		return res;


	}
	
	
}