package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// basic math ops, like +-*/
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public abstract class BitwiseOp extends BinaryOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	BitwiseOp ()
	{
		this("", null);
	}
	

	public 
	BitwiseOp (String strName, Token tok)
	{
		super(strName, tok);
	}
	
	//this function needs to check both operands if they are equal to int
	public STO checkOperands(STO a, STO b) { 
		MyParser.debug(this + ": checking " + a + ", and " + b);
		
		if ( !a.getType().isInt()){
			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1w_Expr, a.getType(), this, "int")));
		}else if ( !b.getType().isInt()) { 
			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1w_Expr, b.getType(), this, "int")));
		} 
		
		return a; 
		 
	}
	
	//this applies the actual operator to the types and returns appropriate type for the ops onvolved
	public STO 
	operate(STO a, STO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res = (new ExprSTO("bitop", new IntType()));
	
		res.setRVal();
		return res;
	}
	
	
	//this needs to be overwritten by each binary op
	public STO
	AsmblyDoOp(STO res, STO a, STO b){
		//no we do the actual op in asmbly
		//this needs to be written thru MyParser, coz it could be in global INIT
		MyParser.asmblyWriteVarSmtComm (this+": L0=" + a.getReg() + "&" + b.getReg(), m_Template, a.getReg(), b.getReg(), L0);
		
		//and signal the res STO that it is stored in L0
		res.setRegister(L0);
		//and return the res expr STO
		return res;
	} 
	
	
	
}