package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.symtab.sto.*;
import  cs131w.parser.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class DivOp extends BasicOp{
	
	
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	DivOp ()
	{
		super("/", new Token (sym.T_SLASH, "/"));
		m_FloatTemplate = FDIV;
		m_Template = ".div";
	}
	
	public STO operate(ConstSTO a, ConstSTO b) throws ArithmeticException{
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res;
		
		if(a.getType().isInt() && b.getType().isInt()){
			res = new ConstSTO( a.getIntValue() / b.getIntValue() );


		}else{
			Double resVal = a.getValue() / b.getValue();
			if(resVal.isNaN() || resVal.isInfinite()){
				throw new ArithmeticException("FP division by zero");
			}
			
			res = new ConstSTO( resVal );
		}
		
		res.setRVal();
		return res;	
	}
	
	
}