package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class LTEOp extends RelOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	LTEOp ()
	{
		super("<=", new Token (sym.T_LTE, "<="));
		m_Template = BLE;
		m_FloatTemplate = FBLE;
	}
	
	
	public STO operate(ConstSTO a, ConstSTO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res;
		
		res = new ConstSTO( a.getValue() <= b.getValue() );
		
		res.setRVal();
		return res;
	}
	
}