package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class ModOp extends BinaryOp{
	
	
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	ModOp ()
	{
		super("%", new Token (sym.T_MOD, "%"));
	}
	
	
	//this function needs to check both operands if they are equal of coercible and return appr type
	public STO checkOperands(STO a, STO b) { 
		MyParser.debug(this + ": checking " + a + ", and " + b);
		
		if ( !a.getType().isInt()){

			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1w_Expr, a.getType(), this, "int")));

		}else if ( !b.getType().isInt()) { 

			return (new ErrorSTO( Formatter.toString(ErrorMsg.error1w_Expr, b.getType(), this, "int")));

		}
		
		return a; 
		
	}
	
	public STO operate(ConstSTO a, ConstSTO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res = new ConstSTO( a.getIntValue() % b.getIntValue() );
		res.setRVal();
		return res;
	}

	
	//this needs to be overwritten by each binary op
	public STO
	AsmblyDoOp(STO res, STO a, STO b){
		//no we do the actual op in asmbly
		//this needs to be written thru MyParser, coz it could be in global INIT
		MyParser.asmblyWriteVarSmtComm ("move op a into out reg", MOVE, a.getReg(), O0);
		MyParser.asmblyWriteVarSmtComm ("move op b into out reg", MOVE, b.getReg(), O1);
		MyParser.asmblyWriteVarSmtComm ("rem: L0= a*b", CALL, ".rem");
		MyParser.asmblyWriteVarSmtComm ("delay slot", NOP);
		
		MyParser.asmblyWriteVarSmtComm ("move res into L0", MOVE, O0, L0);
		//and signal the res STO that it is stored in L0
		res.setRegister(L0);
		//and return the res expr STO
		return res;
	} 
	
	
	
	
}