package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class NeqOp extends EqOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	NeqOp ()
	{
		super("!=", new Token (sym.T_NEQ, "!="));
		m_Template = BNE;
		m_FloatTemplate = FBNE;
	}
	
	public STO operate(ConstSTO a, ConstSTO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res;
		
		if(a.getType().isBool() && b.getType().isBool())
			res = new ConstSTO( a.getBoolValue() != b.getBoolValue() );
//		else if(a.getType().isNull() && b.getType().isNull())
		else if(a.isNull() && b.isNull())
			res = new ConstSTO( true );
		else
			res = new ConstSTO( a.getValue().equals(b.getValue() ));
	
		
		res.setRVal();
		return res;
	}


}