package cs131w.symtab.ops.binary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.*;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import cs131w.util.Utils;
import  cs131w.error.*;


public class OrOp extends BoolOp{
	String trueLabel;
	String endLabel;
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	OrOp ()
	{
		super("||", new Token (sym.T_OR, "||"));
		m_Template = OR;
		trueLabel = Utils.getSomeLabel("orop_true");
		endLabel = Utils.getSomeLabel("orop_end");
	}
	
	public STO operate(ConstSTO a, ConstSTO b){
		MyParser.debug(this + ".operate: '" +a+ "', " + (b));
		STO res = new ConstSTO( a.getBoolValue() || b.getBoolValue() );
		res.setRVal();
		return res;
	}
	
	public STO operate(ConstSTO a){
		throw new RuntimeException();
	}
	
	public void shortCircuit(STO a){
		a.AsmblyLoad();
		MyParser.asmblyWriteVarSmtComm(this + ":", CMP, a.getReg(), "0");
		MyParser.asmblyWriteVarSmtComm(this + ":", BNE, trueLabel);
		MyParser.asmblyWriteVarSmt(NOP);
		operand = a;
		a.AsmblyClearReg();
	}
	
	@Override
	public STO AsmblyDoOp(STO res, STO a, STO b) {
		res.setReg(L0);
		MyParser.asmblyWriteVarSmtComm(this + ": ", m_Template, a.getReg(), b.getReg(), L0);
		MyParser.asmblyWriteVarSmtComm(this + ":", BA, endLabel);
		MyParser.asmblyWriteVarSmt(NOP);
		MyParser.asmblyWriteVarSmt(LABEL, trueLabel);
		MyParser.asmblyWriteVarSmtComm("", SET, "1", L0);
		MyParser.asmblyWriteVarSmt(LABEL, endLabel);
		
		return res;
	}
	
	

}