package cs131w.symtab.ops.unary;

//---------------------------------------------------------------------
// basic math ops, like +-*/
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class AddrOfOp extends UnaryOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	AddrOfOp ()
	{
		super("&", new Token (sym.T_AMPERSAND, "&"));
	}
		
	//function that checks operand of this op
	public STO 
		checkOperand(STO a){
			MyParser.debug(this + ": checking " + a);
	
			if (!a.getIsAddressable()){
				return new ErrorSTO(Formatter.toString(ErrorMsg.error21_AddressOf, a.getType()));
			}		
			
			return a;
			
		}
	
	@Override
	public STO operate(STO a){
		MyParser.debug(this + ".operate: '" + a);
		//check if this is a pointer, in this case we want to just increase the number of refs
		if (a.getType().isBasicPtr()){
			BasicPtrType b = (BasicPtrType) a.getType().getRootType().clone();
			b.setDerefs( b.getDerefs()+1);
			return new ExprSTO(b);
		} 
		
		// if all is well, return a one-up ref'ed pointer to sto
		return new ExprSTO(new BasicPtrType(a.getType(), 1));
	}
	
	
	
	
	//this needs to be overwritten by each unary op
	public STO
	AsmblyDoOp(STO res, STO a){
		
		//load the addr into L0
		a.AsmblyLoadAddr(L0);
		//signal in res
		res.setReg(L0);
		//and return
		return res;
		
	}

}