package cs131w.symtab.ops.unary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.*;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class IncOp extends UnaryIncDecOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	IncOp ()
	{
		super("++", new Token (sym.T_PLUSPLUS, "++"));
		m_Template = INC;
		m_Template_am = INCA;
		m_FloatTemplate = FADD;
		
	}
	
	public STO operate(ConstSTO a) {
		MyParser.debug(this + ".operate: '" + a);
		return new ConstSTO("const_uinc", a.getType(), new Double(a.getValue() + 1));
	}

}