package cs131w.symtab.ops.unary;

//---------------------------------------------------------------------
// basic math ops, like +-*/
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import cs131w.assembly.Regs;
import  cs131w.error.*;


public class MinusOp extends UnaryOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	MinusOp ()
	{
		super("-", new Token (sym.T_MINUS, "-"));
		m_Template = NEG;
		m_FloatTemplate = FNEG;
	}
		
	//function that checks operand of this op
	public STO 
		checkOperand(STO a){
			MyParser.debug(this + ": checking " + a);
			
			if ( !a.getType().isNumeric()){
				return (new ErrorSTO( Formatter.toString(ErrorMsg.error1u_Expr, a.getType(), this, "numeric")));
			} 
			
			return a;
			
		}
	
	@Override
	public STO operate(STO a){
		MyParser.debug(this + ".operate: '" + a);
		return new ExprSTO("-" + a.getName() , a.getType());
	}
	
	public STO operate(ConstSTO a){
		MyParser.debug(this + ".operate: '" + a);
		return new ConstSTO("const_uminus", a.getType(), new Double(-a.getValue()));
	}
	
	@Override
	//move this upward in the class hierarchy if there are other ops that work the exact same way - don't think there are 
	public STO AsmblyDoOp(STO res, STO a){
		if (a.getType().isFloat()){
			String flreg = Regs.getNextFloatReg();
			MyParser.asmblyWriteVarSmtComm (this+": L0= -" + a.getReg() , m_FloatTemplate, a.getReg(), flreg );
			res.setRegister(flreg);
		}else{
			MyParser.asmblyWriteVarSmtComm (this+": L0= -" + a.getReg() , m_Template, a.getReg(), L0);
			res.setRegister(L0);
		}
		return res;
	}
	


}