package cs131w.symtab.ops.unary;

//---------------------------------------------------------------------
// This is the top of the Type hierarchy. You most likely will need to
// create sub-classes (since this one is abstract) that handle specific
// types, such as IntType, FloatType, ArrayType, etc.
//---------------------------------------------------------------------
import cs131w.symtab.ops.*;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class NotOp extends BoolOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	NotOp ()
	{
		super("!", new Token (sym.T_NOT, "!"));
		m_Template = XOR;
	}
	
	public STO operate(ConstSTO a, ConstSTO b){
		throw new RuntimeException();
	}
	
	public STO operate(ConstSTO a){
		MyParser.debug(this + ".operate: '" + a);
		return new ConstSTO( !a.getBoolValue() );
	}

	@Override
	public STO AsmblyDoOp(STO res, STO a) {
		MyParser.asmblyWriteVarSmtComm("NOT " + a, m_Template, a.getReg(), "1", L0);
		a.AsmblyClearReg();
		res.setReg(L0);
		return res;
	}
	
	

}