package cs131w.symtab.ops.unary;

//---------------------------------------------------------------------
// basic math ops, like +-*/
//---------------------------------------------------------------------
import cs131w.symtab.ops.Operator;
import  cs131w.lexer.*;
import  cs131w.parser.*;
import  cs131w.symtab.sto.*;
import  cs131w.symtab.types.*;
import  cs131w.error.*;


public class SizeofOp extends UnaryOp{
	
	//----------------------------------------------------------------
	// ctor
	//----------------------------------------------------------------
	public 
	SizeofOp ()
	{
		super("sizeof", new Token (sym.T_SIZEOF, "sizeof"));
	}
		
	//function that checks operand of this op
	public STO
	checkOperand(STO a){
	
		MyParser.debug(this + ": checking " + a);
		//if its emtpy, it means we are sizeoffing a type
		if (a.isEmpty()) return a;
		
		//check if its addressable
		if (!a.getIsAddressable()){
			return new ErrorSTO(a, ErrorMsg.error19_Sizeof);
		}
		
		return a;
	}
	
	@Override
	public STO operate(STO a){
		MyParser.debug(this + ".operate: '" + a);
		
		//return the size as ConstSTO
		ConstSTO ret = new ConstSTO(a.getSize());
		ret.setRVal();
		MyParser.debug(this + " returning:"+ret);
		
		return ret;
	}

}