package cs131w.symtab.sto;

import cs131w.parser.MyParser;
//---------------------------------------------------------------------
//
//---------------------------------------------------------------------

public class ErrorSTO extends STO
{
	//the sto thats causing the error, if any
	private STO		baseSTO;
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	ErrorSTO ()
	{
		this ("Error");
	}

	public 
	ErrorSTO (Object o)
	{
		this(o.toString());
		if (o instanceof STO) 
			baseSTO = (STO) o;
	}

	public
	ErrorSTO(STO base){
		this(base.toString());
		baseSTO = base;
	}

	public
	ErrorSTO(STO base, String name){
		this(name);
		baseSTO = base;
	}
	
	
	public 
	ErrorSTO (String strName)
	{
		super(strName);
		if(MyParser.DEV){
			setName("Error_" + strName);
		}
		setIsModLValue(true);
	}


	public String
	toString()
	{
		return (m_strName);
	}	

	public STO
	getBase()
	{
		return (baseSTO);
	}	
	//regardless of return type a ErrorSTO always has size 0!
	public int
	getSize(){
		return 0;
	}

	//----------------------------------------------------------------
	//	There are times where it is an error if the STO is not a 
	//	constant or adddressable or something else. However, if
	//	the STO is already an error, nothing should be said. To
	//	supress that error, we would have to check if the STO is
	//	not an ErrorSTO as well as what we want it to be.  Rather
	//	than 2 checks we'll have the ErrorSTO always return true
	//	for every check.  (This is an example of where the
	//	instanceof operator would not have been appropriate.)
	//----------------------------------------------------------------
        public boolean  isVar ()              { return true; }
        public boolean  isConst ()            { return true; }
        public boolean  isExpr ()             { return true; }
        public boolean  isFunc ()             { return true; }
        public boolean  isTypedef ()          { return true; }
        public boolean  isError ()            { return true; }

	public boolean  getIsAddressable ()   { return true; }
	public boolean  getIsModLValue ()     { return true; }
}
