package cs131w.symtab.sto;
//---------------------------------------------------------------------
//
//---------------------------------------------------------------------
import  cs131w.symtab.types.*;
import  cs131w.parser.MyParser;
import  cs131w.assembly.*;

public class ExprSTO extends AdressableSTO
{
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	ExprSTO ()
	{
		this ("Expr");
	}

	public 
	ExprSTO (String strName)
	{
		this (strName, null);
	}

	public 
	ExprSTO (Type t)
	{
		this ("expression", t);
	}

	public 
	ExprSTO (String strName, Type typ)
	{
		super (strName, typ);
        // neither mod nor addr
		setRVal();
		MyParser.debug(this + ".ctor returning.");
		//now create, that is just reserve space
		this.AsmblyCreate();
		m_label = "expr." + m_strName + "$L" + MyParser.GetLineNum();
		
	}
	
	public String
	toString()
	{
		if (MyParser.DEV){
			String ad = "";
			if (isInReg())
				ad = m_register;
			else
				ad = getAddrStr();
				
			return ("(Expr)" + m_strName + ":" + m_type + "@" + ad);
		}else
			return (m_strName);
	}	
	


	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public Object 
	clone() {      //throws CloneNotSupportedException {
		
		STO ret = new ExprSTO(new String(m_strName), (Type)m_type.clone());
		
		MyParser.debug(this+".clone: setting all fields!");
		ret.setLabel(new String(m_label));
		
		ret.setIsModifiable(m_isModifiable);
		ret.setIsAddressable(m_isAddressable);

		//now set the asmbly vars, too
		ret.setReg(m_register);
		ret.setMemBase(mem_base);
		ret.setMemOffset(mem_offset);
		ret.setIsLocal(mem_isLocal);
		if (m_static) ret.setStatic();
		if (asmbl_created) ret.setAsmblyCreated();
		if (hasRuntimeAddr()) ret.setRuntimeAddr((StorageLocation)mem_runtimeAddr.clone());
		
		MyParser.debug(this+".clone: returning " + ret);
		return ret;
	}

	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public boolean
	isExpr () { return	true; }
	
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	
	public void
	AsmblyCreate(){ 
		int off = MyParser.increaseFrameOffset(getSize());
		markLocal(off);
		asmbl_created = true;
	}
	
}
