package cs131w.symtab.sto;
//---------------------------------------------------------------------
// For typedefs like: typedef int myInteger1, myInteger2;
// Also can hold the structdefs
//---------------------------------------------------------------------
import  cs131w.symtab.types.*;
import cs131w.parser.MyParser;

public class TypedefSTO extends AdressableSTO
{
	
	 
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public 
	TypedefSTO ()
	{
		this ("");
	}

	public 
	TypedefSTO (String strName)
	{
		this (strName, null);
	}

	public 
	TypedefSTO (String strName, StructType parent_t)
	{
		super (strName, parent_t);
		setRVal();
		//typedefs are all global (remember structs are typedefs)
		mem_isLocal = false;
	}

	public 
	TypedefSTO (String strName, Type parent_t)
	{
		super (strName, new AliasType(strName, parent_t));
		setRVal();
		//typedefs are all global (remember structs are typedefs)
		mem_isLocal = false;
	}



	//----------------------------------------------------------------
	// gets the parent type of this typedef if its an alias
	//----------------------------------------------------------------
	public Type
	getParentType(){
		if (!m_type.isAlias()){
			//MyParser.debug("typedefsto.parent(no-alias) returning " + m_type );
			return m_type;
		}else{
			//MyParser.debug("typedefsto.parent() returning " + ((AliasType)m_type).getRootType());
			
		 	return ((AliasType)m_type).getRootType();
		}
	}

	//just return the underlying alias type
	public Type
	getType ()
	{
		return	m_type;
	}
	
	public int
	getSize(){
		return getParentType().getSize();
	}
	
	
	public String
	toString()
	{
		if (MyParser.DEV)
			return ("(TypeD)" + m_strName + ":" + m_type);
		else
			return (m_strName);
		
	}	
	
	//----------------------------------------------------------------
	//
	//----------------------------------------------------------------
	public boolean
	isTypedef ()
	{
		return true;
	}
/*
	//structs can only be typedeffed once
	public boolean
	isStruct ()
	{
		return getParentType().isStruct();
	}

	//structs can only be typedeffed once
	public boolean
	isFuncPtr ()
	{
		return getParentType().isFuncPtr();
	}
*/

}
