package cs131w.symtab.types;


public class BasicPtrType extends PtrType
{
	


	//----------------------------------------------------------------
	// just set this to a void pointer, since we dont know the type yet
	// or it might be NULL, and #* to 0
	//----------------------------------------------------------------
	public 
	BasicPtrType ()
	{
		this(new VoidType(), 0);
	}


	public 
	BasicPtrType (Type t, int derefs)
	{
		super("ptr", 4, t, derefs);
	}


	//ptrs actually have state, so override clone
	public Object 
	clone(){
		BasicPtrType ret = new BasicPtrType((Type)m_baseType.clone(), m_numDeref);
		
		return ret;
	}
	
	//----------------------------------------------------------------
	//----------------------------------------------------------------
	public boolean	isBasicPtr ()		{ return true; }
	
	public boolean
	isCastable(Type t){
		if (t.isBasic() || t.isBasicPtr()) return true;
		else return false;
	}
	

	
	//----------------------------------------------------------------
	//	returns a new pointer type, with one less deref
	//  for auto derefing while doing expressions 
	//----------------------------------------------------------------
	public
	Type derefOnce(){
		if (m_numDeref > 1)
			return new BasicPtrType(m_baseType, (m_numDeref-1));
		else
			return m_baseType;
	}
	
	
}