package cs131w.util;
//---------------------------------------------------------------------
//
//---------------------------------------------------------------------

import java.io.*;
import cs131w.assembly.*;
import cs131w.parser.*;


public class LineNumberPushbackStream extends PushbackInputStream
{

	//-----------------------------------------------------------------
	//	Instance variables.
	//-----------------------------------------------------------------
		private int	m_nLine;

		//this is the last line dumped, so dont do it again
		private int	m_lastLine = 0;

		//	I'm saving the name directly because I cannot see
		//	how to get the filename out of a created FileInputStream.
		//	Either I'm stupid or I'm totally missing something.
		private String	m_streamName;
		private BufferedReader in;
		
	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public 
	LineNumberPushbackStream ()
	{
		this (System.in);
		m_streamName = "(stdin)";
	}

	public 
	LineNumberPushbackStream (String strFilename)
	throws FileNotFoundException
	{
		this (new FileInputStream (strFilename));
		m_streamName = strFilename;
		in = new BufferedReader(new FileReader(strFilename));
	}

	public 
	LineNumberPushbackStream (InputStream in)
	{
		//	You should never push back more than 3 characters
		//	(12e-X) but double up to be safe.
		super (in, 6);

		m_nLine = 1;
		m_streamName = "";
	}

	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public String
	getName ()
	{
		return	m_streamName;
	}

	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public void
	dumpLineComment(){
		String line = null;
		
		if (m_nLine <= m_lastLine) return;
		
		try {  line = in.readLine(); }
		catch(IOException e) {
			e.printStackTrace();
			return;
		}
		
		
		if (line != null && line.length() > 0 && !(line.matches("^\\s+$")))
			AssemblyWriter.appendLine("\n\n! (L"+m_nLine+") " + line + "\n");
		
		m_lastLine = m_nLine;
	}

	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public int
	getLineNumber ()
	{
		return (m_nLine);
	}


	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public void
	incLineNumber ()
	{
		m_nLine++;
		dumpLineComment();
	}


	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public void
	decLineNumber ()
	{
		MyParser.debug("Unreading line " + m_nLine);
		m_nLine--;
	}


	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public int
	read () 
	throws IOException
	{
		int	nextChar = super.read();

		if (nextChar == '\n')
			incLineNumber();
		
		return	nextChar;
	}


	//-----------------------------------------------------------------
	//
	//-----------------------------------------------------------------
	public void
	unread (int b) 
	throws IOException
	{
		super.unread (b);

		if (b == '\n')
			decLineNumber();
	}	


}
